<?php
###################################
# Copyright (c) Sternadel Michał
# http://sternadel.pl/
# All rights reserved.
# Version 1.2.5MgS
###################################

#ini_set('error_reporting', 'E_ALL ^E_NOTICE');
#ini_set('display_errors', '1');

class block_mgs_stats extends block_base {
	function init() {
		global $COURSE, $CFG;

		$this->title = get_string('blockname', 'block_mgs_stats');
		$this->version = 2011011001;
		require_once('functions.php');
	}
	function has_config() {
		return true;
	}
	
    function instance_allow_config() {
        global $COURSE;
        // if admin always configure
        if (isadmin()) return true;
        // if not "MyMoodle" and is teacher, can configure
        if (isteacher($COURSE->id)){
            if ($COURSE->id > 1)
                return true;
        }
        return false;
    }
	function config_save($data) {
		// Default behavior: save all variables as $CFG properties
		foreach ($data as $name => $value) {
			set_config($name, $value);
		}
  	return true;
	}
    
	function get_content() {
		global $USER, $CFG, $COURSE;
		
		if ($this->config->block_mgs_stats_level1) $CFG->block_mgs_stats_level1=$this->config->block_mgs_stats_level1;
		if ($this->config->block_mgs_stats_level2) $CFG->block_mgs_stats_level2=$this->config->block_mgs_stats_level2;
		if ($this->config->block_mgs_stats_level3) $CFG->block_mgs_stats_level3=$this->config->block_mgs_stats_level3;

		$this->content = new stdClass;
		$this->content->text = '';
		$this->content->footer = '';
		if ($USER->id && $USER->id!=1) {
			$this->content->text .=initCSS();
			if ($COURSE->id=="1") { //jesli strona glowna:
				if (isadmin()) {
					$courses=getCoursesForAdmin();
					$kurs='all_admin';
				}
				else { 
						$courses=getCoursesForUser($USER->id);
						$kurs='all';	
				}
				if ($courses) {
					$blocktype = get_record('block', 'name', 'mgs_stats' );
 					$instances = get_records('block_instance', 'blockid', $blocktype->id );
					foreach ($instances as $instance) {
 		    			$configdata[$instance->pageid]=unserialize(base64_decode($instance->configdata))->block_mgs_stats_level3;
						if ($configdata[$instance->pageid]) $required[$instance->pageid]=secondsToTime($configdata[$instance->pageid]); else $required[$instance->pageid]=secondsToTime($CFG->block_mgs_stats_level3);
 		    		}
					$this->content->text .= "\n<!-- copyright (c) Sternadel Michał http://sternadel.pl/?from=moodlestats Wszelkie prawa zastrzeżone -->\n";
					$this->content->text .= '<table style="width: 100%;" border="0" cellspacing="0" cellpadding="0" >';
					$this->content->text .= '<tr><td class="legend">' . get_string('course', 'block_mgs_stats') . ':</td><td class="legend">' . get_string('time', 'block_mgs_stats') . ':</td><td class="legend">' . get_string('required', 'block_mgs_stats') . ':</td></tr>';
					foreach ($courses as $course) {
						if (!$required[$course['courseId']]) $required[$course['courseId']]=secondsToTime($CFG->block_mgs_stats_level3);
						$wyniki=getStats($USER->id, $course['courseId']);
							
						if ($wyniki['input']==0) $wyniki['style']='level0';
						elseif ($required[$course['courseId']]['input']<=$wyniki['input']) $wyniki['style'] = 'level3'; 
						else $wyniki['style']='normal';
						
						$this->content->text .= '<tr><td class="'.$wyniki['style'].'">';
						//$this->content->text .= '<tr><td class="normal">';
						$this->content->text .='<a class="'.$wyniki['style']. '" href="'. $CFG->wwwroot .'/course/view.php?id=' . $course['courseId'] . '">' . $course['courseNameShort'] . '</a></td>';
						//$this->content->text .='<a class="normal" href="'. $CFG->wwwroot .'/course/view.php?id=' . $course['courseId'] . '">' . $course['courseNameShort'] . '</a></td>';
						$this->content->text .= '<td class="'.$wyniki['style'].'" style="text-align: center;">';
						//$this->content->text .= '<td class="normal" style="text-align: center;">';
						$this->content->text .= $wyniki['godzin'] . ' ' . get_string('hours') . ' ' . $wyniki['minut'] . ' ' . get_string('mins').'</td>';
						$this->content->text .= '<td class="'.$wyniki['style'].'" style="text-align: center;">';
						//$this->content->text .= '<td class="normal" style="text-align: center;">';
						$this->content->text .= $required[$course['courseId']]['godzin'] . ' ' . get_string('hours') . ' ' . $required[$course['courseId']]['minut'] . ' ' . get_string('mins');
						$this->content->text .='</td></tr>';
					} //foreach
					$this->content->text .= '<tr><td colspan="3" class="legend" style="text-align: center;">';
					$this->content->text .= initLegend();
					$this->content->text .= '</td></tr>';
					$this->content->text .= '</table>';	
				}
			} // courseid=1
			if ($COURSE->id != 1) { // dla strony glownej pokazujemy inne dane
				$wartosci=getStats($USER->id, $COURSE->id);
				
				
				if ($wartosci) {
					$this->content->text .= "\n<!-- copyright (c) Sternadel Michał http://sternadel.pl/?from=moodlestats Wszelkie prawa zastrzeżone -->\n";
					$this->content->text .= '<table style="width: 100%;" border="0" cellspacing="0" cellpadding="0" >';
					if ( ($wartosci['godzin'] > 0) or ($wartosci['minut'] > 0) ) {
						$this->content->text .= '<tr><td colspan="2" class="'.$wartosci['style'].'" style="text-align: center;">';
						$this->content->text .= '<b>';
						$this->content->text .= $wartosci['godzin'] . ' ' . get_string('hours') . ' ' . $wartosci['minut'] . ' ' . get_string('mins');
						$this->content->text .= '</b>';
						$this->content->text .= '</td></tr>';
						$this->content->text .= '<tr><td colspan="2" class="requiredinfo" style="text-align: center;">'.initRequiredInfo().'</td></tr>';
					}
					else {
						$this->content->text .='<tr><td colspan="2" class="level0" style="text-align: center;">';
						$this->content->text .= get_string('noavailablelogs', 'block_mgs_stats');
						$this->content->text .= '</td></tr>';
						$this->content->text .= '<tr><td colspan="2" class="requiredinfo" style="text-align: center;">'.initRequiredInfo().'</td></tr>';
						
					}
				$kurs=$wartosci['kurs'];
				//jesli administrator lub nauczyciel w tym kursie, pokaz czas dla poszczegolnych studentow:
				if (isadmin() or isteacher($COURSE->id)) {
					$students=getStudentsOnCourse($COURSE->id);
					if ($students) {
						$this->content->text .= '<tr><td class="legend">' . get_string('students', 'block_mgs_stats') . ':</td><td class="legend">' . get_string('time', 'block_mgs_stats') . ':</td></tr>';
						foreach ($students as $student) {
							$wyniki=getStats($student['userId'], $student['courseId']);
							$this->content->text .= '<tr><td class="'.$wyniki['style'].'">';
							$this->content->text .='<a class="'.$wyniki['style']. '" href="'. $CFG->wwwroot .'/user/view.php?id=' . $student['userId'] . '&amp;course='.$student['courseId']. '">' . 
							$student['lastname']. ' '. $student['firstname'] . '</a></td>';
							$this->content->text .= '<td class="'.$wyniki['style'].'" style="text-align: center;">';
							$this->content->text .= $wyniki['godzin'] . ' ' . get_string('hours') . ' ' . $wyniki['minut'] . ' ' . get_string('mins');
							$this->content->text .='</td></tr>';						
						} //foreach
						// link do pobierania raportu w rtf:
						$this->content->footer='<a href="' .$CFG->wwwroot .'/blocks/mgs_stats/getreport.php?courseId=' . $student['courseId'] .'">' . get_string('getreport', 'block_mgs_stats') . '</a>';
					}
		    	} // admin/teacher
				$this->content->text .= '<tr><td colspan="2" class="legend" style="text-align: center;">';
				$this->content->text .= initLegend();
				$this->content->text .= '</td></tr>';
			} //wartosci
			else {
				$this->content->text .='<tr><td colspan="2" class="level0" style="text-align: center;">';
				$this->content->text .= get_string('noavailablelogs', 'block_mgs_stats');
				$this->content->text .= '</td></tr>';
			}			
		$this->content->text .= '</table>';
	} //courseId != 1	
	//copyright		
	$this->content->text .= '<div class="sternadelcopy">(c) <a class="sternadelcopy" href="http://sternadel.pl/?from=moodle-';
	$this->content->text .= str_replace(' ', '', str_replace('"','', $kurs));
	$this->content->text .= '" target="_Blank">Sternadel Michał</a>';
	$this->content->text .= '</div>';
	return $this->content;        
	} //userid
	} //function

}//class

?>