<?php

	require_once('../../config.php');
	require_once('libs/PHPRtfLite.php');
	require_once('functions.php');
	require_login();

	 if (isadmin() or isteacher($_GET['courseId']))	{
		$students=getStudentsOnCourse($_GET['courseId']);
		
		if ($students) {

			PHPRtfLite::registerAutoloader();
			//paragraph formats
			$rtf->parFormat = new PHPRtfLite_ParFormat();
			// rtf document
			$rtf = new PHPRtfLite();
			//$this->rtf->setMargins($marginLeft, $marginTop, $marginRight, $marginBottom) {
			$rtf->setMargins(2, 0.5, 2, 0.5);

			//generowanie dokumentu
			$smallfont = new PHPRtfLite_Font(8, 'Arial', '#000000');
			$mainfont = new PHPRtfLite_Font(10, 'Arial', '#000000');
			$headfont = new PHPRtfLite_Font(12, 'Arial', '#000000');
			$headpar = new PHPRtfLite_ParFormat('center');
			$left = new PHPRtfLite_ParFormat('left');
			$center = new PHPRtfLite_ParFormat('center');
			$right = new PHPRtfLite_ParFormat('right');
			
			$header = $rtf->addHeader('all');
			$header->addImage('images/header.png', null, 17);
			$footer = $rtf->addFooter('all');
			$footer->addImage('images/footer.png', null, 17);
			
			$sect = $rtf->addSection();
			$sect->writeText(get_string('reportdate', 'block_mgs_stats').' '. date("Y-m-d H:i:s",mktime()). '<br /><br />', $smallfont, $right);
			$sect->writeText('<br />' . get_string('reporttitle', 'block_mgs_stats'), $headfont, $headpar);
			$courseName=getCourseName($_GET['courseId']);
			$sect->writeText('<b>' . $courseName['courseName'].'</b><br /><br />', $headfont, $headpar);
			$border = PHPRtfLite_Border::create(1, '#000000');
			$table = $sect->addTable();
			$table->addColumnsList(array(1,7,5,2,2));
			$table->addRows(1);
			$table->writeToCell(1, 1, '<b>'. get_string('number', 'block_mgs_stats') .'</b>', $mainfont, $headpar);
			$table->writeToCell(1, 2, '<b>'. get_string('studentslastnameandfirstname', 'block_mgs_stats') . '</b>', $mainfont, $headpar); 
			$table->writeToCell(1, 3, '<b>'. get_string('blockname', 'block_mgs_stats') .'</b>', $mainfont, $headpar);
			$table->writeToCell(1, 4, '<b>'. get_string('startdate', 'block_mgs_stats') .'</b>', $mainfont, $headpar);
			$table->writeToCell(1, 5, '<b>'. get_string('enddate', 'block_mgs_stats') .'</b>', $mainfont, $headpar);
			$table->setBorderForCellRange($border, 1, 1, 1, 5);
			$table->setBackgroundForCellRange('#e8e8e8', 1, 1, 1, 5);
				
			$linia=2;
			foreach ($students as $student) {
				$wyniki=getStats($student['userId'], $student['courseId']);
				$table->addRow(); //, 0.5);
				$table->writeToCell($linia, 1, $linia-1 . '.', $mainfont, new PHPRtfLite_ParFormat('center'));
				$table->writeToCell($linia, 2, $student['lastname'] . ' ' . $student['firstname'], $mainfont, $center);
				$table->writeToCell($linia, 3, $wyniki['godzin'] . ' ' . get_string('hours') . ' ' . $wyniki['minut'] . ' ' . get_string('mins'), $mainfont, $center);
				if ($wyniki['pierwszaaktywnosc']) $startdate=date("Y-m-d H:i:s", $wyniki['pierwszaaktywnosc']); else $startdate='-';
				if ($wyniki['ostatniaaktywnosc']) $enddate=date("Y-m-d H:i:s", $wyniki['ostatniaaktywnosc']); else $enddate='-';
				$table->writeToCell($linia, 4, $startdate, $mainfont, $center);
				$table->writeToCell($linia, 5, $enddate, $mainfont, $center);
			
				$table->setBorderForCellRange($border, $linia, 1, 1, 5);
				$linia++;
			} //foreach
			
			$blocktype = get_record('block', 'name', 'mgs_stats' );
 			$instances = get_records('block_instance', 'blockid', $blocktype->id );
			foreach ($instances as $instance) {
 		    	if ($instance->pageid==$_GET['courseId']) $configdata=unserialize(base64_decode($instance->configdata));
   			}
			if ($configdata->block_mgs_stats_level3) $time=$configdata->block_mgs_stats_level3; else $time=$CFG->block_mgs_stats_level3;
			if($time >= 3600) {
				$value['godzin'] = floor($time/3600);
				$time = ($time%3600);
			}
			if($time >= 60) {
				$value['minut'] = floor($time/60);
				$time = ($time%60);
			}
			if (!$value['godzin']) $value['godzin'] = 0;
			if (!$value['minut']) $value['minut'] = 0;

			$info=get_string('requiredinfo', 'block_mgs_stats').' '. $value['godzin'].' '.get_string('hours').' '. $value['minut'].' '.get_string('mins');
			
			$sect->writeText($info, $smallfont, $left);
			//$sect->writeText(requiredinfo().' '. date("Y-m-d H:i:s",mktime()). '<br /><br />', $smallfont, $right);
			

			$teacherinfo=getTeacherName();
			$sect->writeText('<br /><br /><br />', $mainfont, new PHPRtfLite_ParFormat('justify'));
			$table = $sect->addTable();
			$table -> addRows(3);
			$table->addColumnsList(array(7,10));
			$table->writeToCell(1, 2, '...........................................................................................', $mainfont, $center);
			$table->writeToCell(2, 2, '<b>'. $teacherinfo['firstname'] . ' ' . $teacherinfo['lastname'] .'</b>', $mainfont, $center);	
			$table->writeToCell(3, 2, '<i>('. get_string('signature', 'block_mgs_stats') .')</i>', $smallfont, $center);		
	
			$filename=preg_replace('/ /', '-', $courseName['courseName']);
			$nazwa="MgS_report";
			if ($filename) {$nazwa.='-'.$filename;}
			$nazwa.="-".date("Y-m-d_H-i-s",mktime());	
			$nazwa.=".rtf";
			$rtf->sendRtf($nazwa);
		}
		else {
			die('Brak studentow zapisanych na kurs.');
		}
	} // admin/teacher
		
?>